=== debian/changelog ===
ocp (1:3.2.0+ds-2) unstable; urgency=medium

  * d/control: bump libsdl2-dev to libsdl3-dev in build-depends.

 -- Alex Myczko <tar@debian.org>  Sun, 01 Mar 2026 18:15:20 +0100

ocp (1:3.2.0+ds-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.3.

 -- Alex Myczko <tar@debian.org>  Sun, 01 Mar 2026 17:01:33 +0100
